local cdtable = {}
local PWB = Protwarbar:getPWB()

-- init the table to keep track of when a CD started
for i = 1, PWB_ICON_COUNT do
	cdtable[i] = 0
end

function Protwarbar:UpdateIcons()
	if PWB.db.profile.IconsEnabled == false then
		return nil
	end

	for i = 1, PWB_ICON_COUNT do
		if PWB.db.profile.icons[i].enabled and PWB.db.profile.icons[i].class == PWB.class then 
			Protwarbar:updateIcon(PWB.db.profile.icons[i], PWB.iconFrames[i], PWB.IconCooldown[i], i)
		end
	end
end

function Protwarbar:updateIcon(icon, frame, cooldown, i)
	local start, duration, enabled = GetSpellCooldown(icon.spellid);

	if duration > 1.5 then -- start the CD animations

		if icon.hideOnCD then
			frame.texture:SetAlpha(0)
		else
			if cdtable[i] ~= start then
				cdtable[i] = start
				CooldownFrame_SetTimer(cooldown, start, duration, 1)
			end
		end

	else -- end the CD animations

		if icon.hideOnCD then
			frame.texture:SetAlpha(1)
		else
			if cdtable[i] ~= start then
				CooldownFrame_SetTimer(cooldown, 0, 0, 1)
			end
		end
	end

end